package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.pojo.mes.bean.MesPartProdGroup;
import cn.estsh.i3plus.pojo.mes.bean.MesPartProdGroupDetail;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @CreateDate 2024/04/16
 * @Author mingliang.li
 */
public interface IMesPartProdGroupService extends IBaseMesService<MesPartProdGroup> {

    List<MesPartProdGroup> findMesPartProdGroup(MesPartProdGroupDetail mesPartProdGroupDetail);

    /**
     * 根据工厂和零件生产组code获取零件生产组
     * @param organizeCode
     * @param groupCodeList
     * @return
     */
    List<MesPartProdGroup> findMesPartProdGroups(String organizeCode, List<String> groupCodeList);

    /**
     * 根据pid获取零件生产组详情
     * @param partGroupCode
     * @return
     */
    List<MesPartProdGroupDetail> findDetailByCode(String partGroupCode,String organizeCode);

    Map<String, MesPartProdGroup> getMesPartProdGroupMap(String organizeCode, List<String> partProdGroupCodeList);
}
