package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesProductionRecord;
import cn.estsh.i3plus.pojo.mes.model.MesProductionRecordModel;
import cn.estsh.i3plus.pojo.mes.model.report.MesProductAccountModel;
import cn.estsh.i3plus.pojo.mes.model.report.MesProductAccountResModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 设备加工记录表
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/28 9:20
 * @Modify:
 **/
public interface IMesProductionRecordService extends IBaseMesService<MesProductionRecord> {

    @ApiOperation(value = "根据条码查询设备加工记录表")
    List<MesProductionRecord> findMesProductionRecord(String organizeCode, String sn);

    ListPager queryRecordGroupByPartNoWorkCellCode(MesProductionRecord mesProductionRecord, Pager pager);

    @ApiOperation(value = "线边库存报表")
    ListPager<MesProductionRecordModel> queryMesProductionOffLine(MesProductionRecordModel mesProductionRecordModel,Pager pager);

    @ApiOperation(value = "线边库存报表")
    ListPager<MesProductAccountResModel> queryProductAccount(MesProductAccountModel productAccountModel, Pager pager);

    @ApiOperation(value = "线边库存报表")
    List<MesProductAccountResModel> queryProductAccount(MesProductAccountModel productAccountModel);

    @ApiOperation(value = "线边库存报表")
    List<MesProductAccountResModel> transferAccount(List<MesProductAccountResModel> list,MesProductAccountModel productAccountModel, Pager pager);
}
