package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.model.MesShippingOrderManagementDetailModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrder;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderPart;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesShippingOrderManagementDetail;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description:
 * @CreateDate 2024/04/16
 * @Author mingliang.li
 */
public interface IMesShippingOrderManagementDetailService extends IBaseMesService<MesShippingOrderManagementDetail> {


    public ListPager<MesShippingOrderManagementDetailModel> queryDetailGroupByPartNo(MesShippingOrderManagementDetail bean, Pager pager);

    @ApiOperation("查询发运单明细")
    ListPager<MesShippingOrderManagementDetailModel> queryMesShippingDetailsByPager(MesShippingOrderManagementDetailModel mesShippingOrderManagementDetailModel, Pager pager);

    @ApiOperation("查询发运单明细")
    ListPager<MesShippingOrderManagementDetailModel> queryMesShippingErrorDetailsByPager(MesShippingOrderManagementDetailModel mesShippingOrderManagementDetailModel, Pager pager);


    @ApiOperation("根据客户零件匹配零件号")
    public ResultBean supplyBycustPartNo(Long[] ids);


    @ApiOperation("根据CBR匹配零件号")
    public ResultBean supplyByCBR(Long[] ids);

    @ApiOperation("手动发运改数量")
    public ResultBean updateQty(Long[] ids);

    @ApiOperation("同步")
    public ResultBean syncShip(Long[] ids);

    @ApiOperation("发运退回")
    void doShippingBack(Long[] idList,String organizeCode,String userName);

    @ApiOperation("查询发运零件子零件明细")
    ListPager<MesWorkOrderPart> queryDetailMesWorkOrderPart(MesWorkOrderPart bean, Pager pager);

    void doHandleCockpitShippingError(MesShippingOrderManagementDetail detail, MesWorkOrder workOrder);
}
