package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.ext.mes.pojo.model.WorkOrderMaterialCutModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesCutSchemeFg;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderCut;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderCutDetail;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @CreateDate 2024/04/16
 * @Author mingliang.li
 */
public interface IMesWorkOrderCutService extends IBaseMesService<MesWorkOrderCut> {

    @ApiOperation("生成裁片工单")
    void doGenerateCutWorkOrder(List<Long> workOrderIds, String cutCode, String remark, String organizeCode,
                                String userName, Integer editionNumber, boolean isFree, List<MesCutSchemeFg> mesCutSchemeFgs);

    @ApiOperation("生成裁片工单")
    void generateCutWorkOrderMaterial(WorkOrderMaterialCutModel workOrderMaterialCutModel);


    @ApiOperation("分页查询裁片工单明细")
    ListPager<MesWorkOrderCutDetail> queryWorkOrderCutDetailByPager(MesWorkOrderCutDetail workOrderCutDetail, Pager pager);

    //@ApiOperation("分页查询裁片工单明细")
    //ListPager<MesWorkOrderCutDetail> queryWorkOrderCutDetailByPager(MesWorkOrderCutDetail workOrderCutDetail, Pager pager);

    @ApiOperation("发布裁片工单")
    void doReleaseCutWorkOrder(List<String> cutWorkOrderNos, String organizeCode, String userName);

    @ApiOperation("打印裁片工单")
    List<Map<String, Object>> doPrintCutWorkOrder(List<String> cutWorkOrderNos, String organizeCode, String userName);

    @ApiOperation("重新打印-修改同步状态为未同步")
    void doUpdatePrintStatus(List<String> cutWorkOrderIds, String organizeCode, String userName);

}
