package cn.estsh.i3plus.ext.mes.api.base.file;

import cn.estsh.i3plus.ext.mes.api.base.IBaseMesService;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesFile;
import cn.estsh.i3plus.pojo.mes.bean.MesModuleExcel;
import cn.estsh.i3plus.pojo.mes.model.MesModuleExcelModel;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;

/**
 * @Description : 模块EXCEL管理表
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/17 15:02
 * @Modify:
 **/
public interface IMesModuleExcelService extends IBaseMesService<MesModuleExcel> {

    /**
     * 按条件分页查询模块EXCEL模板信息
     *
     * @param mesModuleExcel 查询条件
     * @param pager          分页条件
     * @return SOP分页数据
     */
    @ApiOperation(value = "按条件分页查询模块EXCEL模板信息", notes = "按条件分页查询模块EXCEL模板信息")
    ListPager<MesModuleExcelModel> queryModuleExcelByPager(MesModuleExcel mesModuleExcel, Pager pager);

    /**
     * 新增模块EXCEL模板信息
     *
     * @param file           文件
     * @param mesModuleExcel 模块EXCEL模板信息
     */
    @ApiOperation(value = "新增模块EXCEL模板信息", notes = "新增模块EXCEL模板信息")
    void insertModuleExcel(MultipartFile file, MesModuleExcel mesModuleExcel);

    /**
     * 更新模块EXCEL模板信息
     *
     * @param file           文件
     * @param mesModuleExcel 模块EXCEL模板信息
     */
    @ApiOperation(value = "更新模块EXCEL模板信息", notes = "更新模块EXCEL模板信息")
    void updateModuleExcel(MultipartFile file, MesModuleExcel mesModuleExcel);
}
