package cn.estsh.i3plus.ext.mes.api.busi.report;

import cn.estsh.i3plus.ext.mes.pojo.model.report.MesDeviceDataQueryReportConditionModel;
import cn.estsh.i3plus.ext.mes.pojo.model.report.MesDeviceDataQueryReportResultModel;
import cn.estsh.i3plus.ext.mes.pojo.model.report.MesProdRuleReportConditionModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesCokpitKanbanData;
import cn.estsh.i3plus.pojo.mes.bean.MesProduceSn;
import cn.estsh.i3plus.pojo.mes.model.MesProductionRecordModel;
import cn.estsh.i3plus.pojo.mes.model.report.MesGeneralExportReportModel;
import cn.estsh.i3plus.pojo.mes.model.report.MesGeneralShippingReportModel;
import cn.estsh.i3plus.pojo.mes.model.report.MesTraceabilityReportModel;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 报表-业务方法
 * @Reference :
 * @Author : logic
 * @CreateDate : 2024/6/15 11:30
 * @Modify:
 **/
public interface IMesYfReportService {

    /**
     * 设备数据查询报表-查询
     * @param queryReportModel 查询条件封装
     * @param pager 分页信息
     * @return 分页查询结果
     */
    ListPager<MesDeviceDataQueryReportResultModel> queryMesDeviceDataByPager(MesDeviceDataQueryReportConditionModel queryReportModel, Pager pager);

    /**
     * 产线产品加工规则报表-查询
     * @param queryReportModel 查询条件封装
     * @param pager 分页信息
     * @return 分页查询结果
     */
    ResultBean queryMesProdRuleByPager(MesProdRuleReportConditionModel queryReportModel, Pager pager);

    ListPager<MesProduceSn> queryMesSuspiciousSnMsgByPager(MesProduceSn mesProduceSn, Pager pager);

    @ApiOperation("查询追溯报表")
    List<MesTraceabilityReportModel> findTraceabilityReport(MesProduceSn mesProduceSn);

    @ApiOperation("零件条码状态查询")
    ListPager<MesProduceSn> queryMesProduceSn(MesProduceSn mesProduceSn, Pager pager);

    @ApiOperation("产品加工记录")
    ListPager<MesProductionRecordModel> queryMesProductionRecord(MesProductionRecordModel mesProductionRecordModel, Pager pager);

    @ApiOperation("看板数据")
    ListPager<MesCokpitKanbanData> queryMesCokpitKanbanData(MesCokpitKanbanData kanbanData, Pager pager);

    @ApiOperation("通用导出报表")
    ListPager<MesGeneralExportReportModel> queryGeneralExport(MesGeneralExportReportModel mesGeneralExportReportModel, Pager pager);

    @ApiOperation("通用发运报表查询")
    ListPager<MesGeneralShippingReportModel> queryGeneralShipping(MesGeneralShippingReportModel model, Pager pager);
}
