import cn.estsh.i3plus.pojo.base.bean.DdlPackBean
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack
import cn.estsh.i3plus.pojo.mes.bean.MesEquipment
import cn.estsh.i3plus.pojo.mes.bean.MesProduceSn
import cn.estsh.i3plus.pojo.mes.bean.MesPartShippingGroup
import cn.estsh.i3plus.pojo.mes.dbinterface.MesInterfaceDataMapper
import cn.estsh.i3plus.pojo.mes.repository.MesEquipmentRepository
import cn.estsh.i3plus.pojo.mes.repository.MesProduceSnRepository
import cn.estsh.i3plus.pojo.mes.repository.MesPartShippingGroupRepository
import org.slf4j.Logger
import org.slf4j.LoggerFactory
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.util.StringUtils

/**
 * @Description : MES2PISCES-发运单
 * @Reference :
 * @Author : gsz
 * @CreateDate 2024/7/14 10:59
 * @Modify:
 * */
class MesToPiscesMesShipping {

    public static final Logger LOGGER = LoggerFactory.getLogger(MesToPiscesMesShipping.class)

    @Autowired
    private MesPartShippingGroupRepository mesPartShippingGroupRepository;

    def filterData(MesInterfaceDataMapper mapper, List<Map<String, Object>> srcData) throws Exception {
        if (srcData == null || srcData.size() == 0) {
            return srcData
        }
        Map<String, MesPartShippingGroup> mesPartShippingGroupMap = new HashMap<>();
        String organizeCode = mapper.getOrganizeCode();
        for (Map<String, Object> rowMap : srcData) {
            //装配条码ID
            if (!StringUtils.isEmpty(rowMap.get("shipping_group_code"))) {
                MesPartShippingGroup mesPartShippingGroup = getMesPartShippingGroup(organizeCode, String.valueOf(rowMap.get("shipping_group_code")), mesPartShippingGroupMap)
                if (!Objects.isNull(mesPartShippingGroup)) {
                    rowMap.put("PART_SHIPPING_FID", mesPartShippingGroup.getFid())
                } else {
                    rowMap.put("PART_SHIPPING_FID", null)
                    LOGGER.info("shipping_group_code:{}信息不存在", String.valueOf(rowMap.get("shipping_group_code")))
                }
            }else{
                rowMap.put("PART_SHIPPING_FID", null)
            }
        }
        return srcData;
    }

    private MesPartShippingGroup getMesPartShippingGroup(String organizeCode, String shippingGroupCode, Map<String, MesPartShippingGroup> mesPartShippingGroupMap) {
        if (Objects.isNull(mesPartShippingGroupMap) || !mesPartShippingGroupMap.containsKey(shippingGroupCode)) {
            DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
            DdlPreparedPack.getStringEqualPack(shippingGroupCode, "shippingGroupCode", ddlPackBean);
            mesPartShippingGroupMap.put(shippingGroupCode, mesPartShippingGroupRepository.getByProperty(ddlPackBean))
        }
        return mesPartShippingGroupMap.get(shippingGroupCode);
    }

}