package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base.MesCustomerMessagePointService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.mes.bean.MesCustomerMessagePoint;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkCenter;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 客户信息点
 */
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesCustomerMessagePoint")
public class MesCustomerMessagePointController extends BaseMesController<MesCustomerMessagePoint>{

    @Autowired
    private MesCustomerMessagePointService mesCustomerMessagePointService;
    //根据客户工厂查找对应的信息点信息
    @GetMapping("/list/{custOrganizeCode}")
    @ApiOperation(value = "查询当前客户工厂的信息点", notes = "查询当前客户工厂的信息点")
    public ResultBean list(@PathVariable("custOrganizeCode") String custOrganizeCode){
        try {
            List<MesCustomerMessagePoint> messagePoints = mesCustomerMessagePointService.getByCustOrganizeCode(custOrganizeCode);
            return ResultBean.success("查询成功").setResultList(messagePoints);
        } catch (Exception e) {
            return ResultBean.fail("查询失败").setErrorMsg(e.getMessage());
        }
    }
}
