package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesEquipmentSpotCheckDetailService;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.excel.MesExcelTool;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentSpotCheckDetail;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.RedisCacheTool;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * 设备点检明细
 */
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesEquipmentCheckDetail")
public class MesEquipmentCheckDetailController extends BaseMesController<MesEquipmentSpotCheckDetail>{

    @Autowired
    private IMesEquipmentSpotCheckDetailService mesEquipmentSpotCheckDetailService;

    @PostMapping(value = "/data/import")
    @ApiOperation(value = "导入数据校验返回")
    public ResultBean importExtExcel(@RequestParam("file") MultipartFile file, @RequestParam("equipmentCode") String equipmentCode) {
        try {
            MesExcelTool excelTool = new MesExcelTool(entityManager, RedisCacheTool.getImppRedis());
            List<MesEquipmentSpotCheckDetail> beanList = excelTool.importData(file.getOriginalFilename(), file.getInputStream(), mesClass);

            // 校验导入数据
            List<MesEquipmentSpotCheckDetail> returnImport = mesEquipmentSpotCheckDetailService.validateReturnImport(beanList, equipmentCode);
            String userName = AuthUtil.getSessionUser().getUserName();
            String organizeCode = AuthUtil.getOrganize().getOrganizeCode();
            // 导入数据初始化
            /*   String userName = "zxw";
            String organizeCode = "CK01";*/
            for (MesEquipmentSpotCheckDetail bean : returnImport) {
                ConvertBean.serviceModelInitialize(bean, userName);
                bean.setOrganizeCode(organizeCode);
            }
            baseService.insertBatch(returnImport);

            // 导入后
            afterImport(returnImport);
            return ResultBean.success("导入成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }
}
