package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesPartService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesPart;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 零件管理
 */
@Api("物料信息")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesPart")
public class MesPartController extends BaseMesController<MesPart>{

    @Autowired
    private IMesPartService mesPartService;

    @ApiOperation(value = "查询物料信息", notes = "查询物料信息")
    @GetMapping("/query-ext")
    public ResultBean queryMesProdRuleByPager(MesPart mesPart, Pager pager){
        try {
            String organizeCode = AuthUtil.getOrganize().getOrganizeCode();
            mesPart.setOrganizeCode(organizeCode);
            return ResultBean.success("查询物料信息成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).
                    setListPager(mesPartService.queryMesPartByPagerExt(mesPart, pager));
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
