package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesProductVersionService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesProductVersion;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
@Api("生产版本")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesProductVersion")

public class MesProductVersionController extends BaseMesController<MesProductVersion>{

    @Autowired
    private IMesProductVersionService mesProductVersionService;

    @ApiOperation(value = "查询生产版本", notes = "查询生产版本")
    @GetMapping("/query-ext")
    public ResultBean queryMesProdRuleByPager(MesProductVersion mesProductVersion, Pager pager){
        try {
            String organizeCode = AuthUtil.getOrganize().getOrganizeCode();
            mesProductVersion.setOrganizeCode(organizeCode);
            ListPager<MesProductVersion> productVersionListPager = mesProductVersionService.queryMesProductVersionByPagerExt(mesProductVersion, pager);
            return ResultBean.success("查询生产版本成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).
                    setListPager(productVersionListPager);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
