package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesPullingOrderInfoService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesPullingOrderInfo;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 拉动单
 */
@Api("拉动单")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesPullingOrderInfo")
public class MesPullingOrderInfoController extends BaseMesController<MesPullingOrderInfo> {
    @Autowired
    private IMesPullingOrderInfoService mesPullingOrderInfoService;

    @GetMapping(value = "/doRePrint")
    @ApiOperation(value = "拉动单补打")
    public ResultBean doMesPullingOrderInfoPrint(MesPullingOrderInfo mesPullingOrderInfo) {
        try {
            if (StringUtils.isEmpty(mesPullingOrderInfo.getPullingOrderNo())) {
                throw new ImppBusiException("拉动单号不能为空");
            }
            List<MesPullingOrderInfo> pullingOrderInfos = mesPullingOrderInfoService.doMesPullingOrderInfoPrint(mesPullingOrderInfo, AuthUtil.getSessionUser().getUserName());
            return ResultBean.success("拉动单打印成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setResultList(pullingOrderInfos);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }
}
