package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkOrderLogService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderLog;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description :  报工调整报表
 * @Reference :
 * @Author : gsz
 * @CreateDate 2024/8/26 17:50
 * @Modify:
 **/
@Api(" 报工调整报表")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesWorkOrderLog")
public class MesWorkOrderLogController extends BaseMesController<MesWorkOrderLog>{
    @Autowired
    private IMesWorkOrderLogService mesWorkOrderLogService;

    @GetMapping(value = "/group-by-order-no/query")
    @ApiOperation(value = "报工调整报表", notes = "报工调整报表")
    public ResultBean queryMesWorkOrderLogByPage(MesWorkOrderLog mesWorkOrderLog, Pager pager) {
        try {
            ValidatorBean.beginValid(mesWorkOrderLog)
                    .notNull("organizeCode", mesWorkOrderLog.getOrganizeCode());

            return ResultBean.success("查询成功").setListPager(mesWorkOrderLogService.queryMesWorkOrderLogByPage(mesWorkOrderLog, pager))
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
