package cn.estsh.i3plus.ext.mes.apiservice.controller.board;

import cn.estsh.i3plus.ext.mes.api.busi.board.IMesYfBoardService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.ext.mes.pojo.model.board.MesGepicsInspectionInfoModel;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description : 报表
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/10/11 13:58
 * @Modify:
 **/
@Api("报表")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/board")
public class MesBusiBoardController {

    @Autowired
    private IMesYfBoardService mesYfBoardService;

    @ApiOperation(value = "查询V107Melos数据", notes = "查询V107Melos数据")
    @PostMapping("/query-gepics-inspection-info")
    public ResultBean queryGepicsInspectionInfo(@RequestBody MesGepicsInspectionInfoModel infoModel, Pager pager){
        try {
            ValidatorBean.beginValid(infoModel)
                    .notNull("organizeCode", infoModel.getOrganizeCode());
            return ResultBean.success("查询成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setListPager(mesYfBoardService.queryGepicsInspectionInfo(infoModel,pager));
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }
}
