package cn.estsh.i3plus.ext.mes.apiservice.controller.busi;

import cn.estsh.i3plus.ext.mes.api.busi.report.IMesYfReportService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesProduceSn;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * @Description: 报表
 * @Author: gsz
 * @Date: 2024/6/17 15:16
 * @Modify:
 */
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/report")
public class MesReportBusiController {

    @Autowired
    private IMesYfReportService mesYfReportService;

    @GetMapping("/query-suspicious-sn")
    @ApiOperation(value = "分页查询可疑品条码信息")
    public ResultBean queryMesSuspiciousSnMsgByPager(MesProduceSn mesProduceSn, Pager pager) {
        try {

            ListPager<MesProduceSn> mesWorkCellExtendCfgByPager = mesYfReportService.queryMesSuspiciousSnMsgByPager(mesProduceSn, pager);
            return ResultBean.success("查询主子工位关系成功").setListPager(mesWorkCellExtendCfgByPager);
        } catch (ImppBusiException imppException) {
            return ResultBean.fail(imppException);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }


}
