package cn.estsh.i3plus.ext.mes.apiservice.controller.busi;

import cn.estsh.i3plus.ext.mes.api.base.IMesBtoJobService;
import cn.estsh.i3plus.ext.mes.apiservice.schedulejob.*;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

@RestController
@RequestMapping("/test")
public class TestController {


    @Autowired
    private MesWorkOrderUpdateQtyJob mesWorkOrderUpdateQtyJob;

    @Autowired
    private MesAccountJob mesAccountJob;

    @Autowired
    private MesGenerateAccountJob mesGenerateAccountJob;

    @Autowired
    private MesDowntimeRecordJob mesDowntimeRecordJob;

    @Autowired
    private MesQmsScrapJob mesQmsScrapJob;

    @Autowired
    private IMesBtoJobService btoJobService;

    @GetMapping("/reportOrder")
    @ApiOperation(value = "报工")
    public void reportOrder() {
        mesWorkOrderUpdateQtyJob.executeMesJob(null, null);
    }

    @GetMapping("/mesAccount")
    @ApiOperation(value = "报工")
    public void mesAccount() {

        String organizeCode = "CK01";
        List<String> groupCodeList = Stream.of("CS001","IP002","IP001","CS002").collect(Collectors.toList());
        btoJobService.doCreateBto(organizeCode, groupCodeList);

        //mesAccountJob.executeMesJob(null, null);
    }

    @PostMapping("/bto")
    public void create(@RequestParam String organizeCode, @RequestParam List<String> groupCodeList){
        btoJobService.doCreateBto(organizeCode, groupCodeList);
    }

    @GetMapping("/generateMesAccount")
    @ApiOperation(value = "generateMesAccount")
    public void generateMesAccount() {
        mesGenerateAccountJob.executeMesJob(null, null);
    }


    @GetMapping("/mesDowntimeRecordJob")
    @ApiOperation(value = "downtime")
    public void mesDowntimeRecordJob() {
        mesDowntimeRecordJob.executeMesJob(null, null);
    }


    @GetMapping("/mesQmsScrap")
    @ApiOperation(value = "mesQmsScrap")
    public void mesQmsScrap() {
        mesQmsScrapJob.executeMesJob(null, null);
    }
}
