package cn.estsh.i3plus.ext.mes.apiservice.controller.report;

import cn.estsh.i3plus.ext.mes.api.busi.report.IMesYfReportService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.ext.mes.pojo.model.report.MesProdRuleReportConditionModel;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.impp.framework.base.controller.MesBaseController;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description : 产线产品加工规则报表
 * @Reference :
 * @Author : logic
 * @CreateDate : 2024/6/17 15:37
 * @Modify:
 **/
@Api("产线产品加工规则报表")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/prod-rule-report")
public class MesProdRuleReportController extends MesBaseController {

    @Autowired
    private IMesYfReportService mesYfReportService;

    @ApiOperation(value = "查询产线产品加工规则报表", notes = "查询产线产品加工规则报表")
    @GetMapping("/query")
    public ResultBean queryMesProdRuleByPager(MesProdRuleReportConditionModel conditionModel, Pager pager){
        try {
            ValidatorBean.beginValid(conditionModel).notNull("isSort", conditionModel.getIsSort());
            String organizeCode = AuthUtil.getOrganize().getOrganizeCode();
            conditionModel.setOrganizeCode(organizeCode);
            return  mesYfReportService.queryMesProdRuleByPager(conditionModel, pager);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
