package cn.estsh.i3plus.ext.mes.apiservice.controller.report;

import cn.estsh.i3plus.ext.mes.api.busi.report.IMesWorkCellScanMonitorLogService;
import cn.estsh.i3plus.ext.mes.apiservice.controller.base.BaseMesController;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.ext.mes.pojo.model.report.MesWorkCellScanMonitorConditionModel;
import cn.estsh.i3plus.ext.mes.pojo.model.report.MesWorkCellScanMonitorLogModel;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkCellScanMonitorLog;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @Description :工位扫描日志合并设备日志报表
 * @Reference :
 * @Author : wangjie
 * @CreateDate : 2023/02/06 09:59
 * @Modify:
 **/
@Api(tags = "工位扫描日志合并设备日志报表")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesWorkCellScanMonitorLog")
public class MesWorkCellScanMonitorLogController extends BaseMesController<MesWorkCellScanMonitorLog> {

    @Autowired
    private IMesWorkCellScanMonitorLogService workCellScanMonitorLogService;

    @GetMapping(value = "/monitor-and-logdetail/report/query")
    @ApiOperation(value = "查询工位扫描日志合并设备日志报表")
    public ResultBean queryWorkCellScanMonitorLogList(MesWorkCellScanMonitorConditionModel conditionModel) {
        try {
            conditionModel.setOrganizeCode(AuthUtil.getOrganize().getOrganizeCode());
            List<MesWorkCellScanMonitorLogModel> result = workCellScanMonitorLogService.queryWorkCellScanMonitorLogList(conditionModel);
            return ResultBean.success("查询成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(result);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
