package cn.estsh.i3plus.ext.mes.apiservice.controller.report;

import cn.estsh.i3plus.ext.mes.api.busi.report.IProductInspectionSubReportService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesQmsSuspicious;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description : 检验产品数据子报表
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/29 13:48
 * @Modify:
 **/
@Api("检验产品数据子报表")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/product-inspection-sub-report")
public class ProductInspectionSubReportController {

    @Autowired
    private IProductInspectionSubReportService productInspectionSubReportService;

    @ApiOperation(value = "检验产品数据子报表")
    @PostMapping("/queryReport")
    public ResultBean queryReport(MesQmsSuspicious model, Pager pager) {
        try {
            model.setOrganizeCode(AuthUtil.getOrganize().getOrganizeCode());
            ListPager<MesQmsSuspicious> result = productInspectionSubReportService.queryReport(model,pager);
            return ResultBean.success("查询成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setListPager(result);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }
}
