package cn.estsh.i3plus.ext.mes.apiservice.controller.report;

import cn.estsh.i3plus.ext.mes.api.busi.report.ISuspiciousItemBarcodeReportService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.model.report.SuspiciousItemBarcodeReportModel;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description :可疑品条码信息报表
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/28 18:53
 * @Modify:
 **/
@Api("可疑品条码信息报表")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/suspicious-item-barcode-report")
public class SuspiciousItemBarcodeReportController {

    @Autowired
    private ISuspiciousItemBarcodeReportService suspiciousItemBarcodeReportService;

    @ApiOperation(value = "查询可疑品条码信息报表")
    @PostMapping("/queryReport")
    public ResultBean queryReport(SuspiciousItemBarcodeReportModel model, Pager pager) {
        try {
            model.setOrganizeCode(AuthUtil.getOrganize().getOrganizeCode());
            ListPager<SuspiciousItemBarcodeReportModel> result = suspiciousItemBarcodeReportService.queryReport(model,pager);
            return ResultBean.success("查询成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setListPager(result);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }
}
