package cn.estsh.i3plus.ext.mes.apiservice.dao;

import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesModuleExcel;
import cn.estsh.i3plus.pojo.mes.model.MesModuleExcelModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 模块EXCEL管理
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/17 14:28
 * @Modify:
 **/
public interface IMesModuleExcelDao {

    /**
     * 查询模块EXCEL管理数量
     *
     * @param mesModuleExcel 模块EXCEL管理信息
     * @return 数量
     */
    @ApiOperation(value = "查询模块EXCEL管理数量", notes = "查询模块EXCEL管理数量")
    int queryModuleExcelCount(MesModuleExcel mesModuleExcel);

    /**
     * 查询模块EXCEL管理信息集合
     *
     * @param mesModuleExcel 查询条件
     * @param pager          分页条件
     * @return 模块EXCEL管理信息集合
     */
    @ApiOperation(value = "查询模块EXCEL管理信息集合", notes = "查询模块EXCEL管理信息集合")
    List<MesModuleExcelModel> queryModuleExcelByPager(MesModuleExcel mesModuleExcel, Pager pager);
}
