package cn.estsh.i3plus.ext.mes.apiservice.daoimpl;

import cn.estsh.i3plus.ext.mes.apiservice.dao.IMesProdRuleNosortCfgDao;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesProdRuleNosortCfg;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.util.List;

@Service
@Slf4j
public class MesProdRuleNosortCfgDaoImpl implements IMesProdRuleNosortCfgDao {

    @Autowired
    private EntityManager entityManager;

    @Override
    public List<MesProdRuleNosortCfg> findMesProdRuleNosortCfgByWorkCenterCode(String workCenterCode, String partNo, String organizeCode) {
        StringBuffer hql = new StringBuffer("select ns from MesProdRuleNosortCfg ns" +
                " left join MesWcEquipment we on ns.equipmentCode = we.equipmentCode " +
                " where ns.isDeleted=:isDeleted and ns.isValid = :isValid and ns.organizeCode = :organizeCode " +
                " and we.isDeleted=:isDeleted and we.isValid = :isValid and we.organizeCode = :organizeCode " +
                " and we.workCenterCode = :workCenterCode and ns.outPartNo = :outPartNo");

        Query query = entityManager.createQuery(hql.toString(), MesProdRuleNosortCfg.class);
        query.setParameter("organizeCode", organizeCode);
        query.setParameter("isValid", CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue());
        query.setParameter("isDeleted", CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
        query.setParameter("workCenterCode", workCenterCode);
        query.setParameter("outPartNo", partNo);

        return query.getResultList();
    }

    @Override
    public List<MesProdRuleNosortCfg> findMesProdRuleNosortCfgByWorkCellCode(String workCellCode, String partNo, String organizeCode) {
        StringBuffer hql = new StringBuffer("select ns from MesProdRuleNosortCfg ns" +
                " left join MesWcEquipment we on ns.equipmentCode = we.equipmentCode " +
                " where ns.isDeleted=:isDeleted and ns.isValid = :isValid and ns.organizeCode = :organizeCode " +
                " and we.isDeleted=:isDeleted and we.isValid = :isValid and we.organizeCode = :organizeCode " +
                " and we.workCellCode = :workCellCode and ns.inPartNo = :inPartNo order by ns.createDatetime desc");

        Query query = entityManager.createQuery(hql.toString(), MesProdRuleNosortCfg.class);
        query.setParameter("organizeCode", organizeCode);
        query.setParameter("isValid", CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue());
        query.setParameter("isDeleted", CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue());
        query.setParameter("workCellCode", workCellCode);
        query.setParameter("inPartNo", partNo);

        return query.getResultList();
    }
}
