package cn.estsh.i3plus.ext.mes.apiservice.schedulejob;

import cn.estsh.i3plus.ext.mes.api.base.IMesConfigService;
import cn.estsh.i3plus.ext.mes.api.base.IMesPullingOrderInfoService;
import cn.estsh.i3plus.ext.mes.api.busi.IMesOfflineService;
import cn.estsh.i3plus.mes.apiservice.schedulejob.BaseMesScheduleJob;
import cn.estsh.impp.framework.boot.init.ApplicationProperties;
import com.alibaba.fastjson.JSONObject;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.JobExecutionContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import javax.persistence.Column;
import java.util.List;
import java.util.Map;

/**
 * @Description : 根据拉动组和生产工单产生拉动单JOB
 * @Reference :
 * @Author : gsz
 * @CreateDate 2024/9/4 10:01
 * @Modify:
 **/
// 禁止 JOB 并发执行
@ApiOperation("生产所有总成零件的装配件模板")
@Component
public class MesCreateSortRuleCfgOfflineJob extends BaseMesScheduleJob {

    public static final Logger LOGGER = LoggerFactory.getLogger(MesCreateSortRuleCfgOfflineJob.class);


    @Autowired
    private IMesOfflineService mesOfflineService;


    public MesCreateSortRuleCfgOfflineJob() {
        super(MesCreateSortRuleCfgOfflineJob.class, "生产所有总成零件的装配件模板");
        this.setMultiInstance(true);
    }

    @Override
    public void executeMesJob(JobExecutionContext context, ApplicationProperties applicationProperties) {
        Map<String,Object> paramMap = (Map<String, Object>) JSONObject.parse(this.getJobParam());
        try {
            String organizeCode = (String) paramMap.get("organizeCode");
            List<String> groupCodeList = (List<String>) paramMap.get("partProdCodeList");
            mesOfflineService.doCreateSortRuleCfgOfflineData(organizeCode,groupCodeList);
        } catch (Exception e) {
            LOGGER.error("生产所有总成零件的装配件模板:{}", e.toString());
        }
    }

}
