package cn.estsh.i3plus.ext.mes.apiservice.schedulejob;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkOrderService;
import cn.estsh.i3plus.mes.apiservice.schedulejob.BaseMesScheduleJob;
import cn.estsh.impp.framework.boot.init.ApplicationProperties;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.JobExecutionContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @Description : 工单关闭
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/8/28 9:52
 * @Modify:
 **/
@DisallowConcurrentExecution
@ApiOperation("工单关闭")
public class MesWorkOrderCloseOrderJob extends BaseMesScheduleJob {

    public static final Logger LOGGER = LoggerFactory.getLogger(MesWorkOrderCloseOrderJob.class);

    @Autowired
    private IMesWorkOrderService mesWorkOrderService;

    public MesWorkOrderCloseOrderJob() {
        super(MesWorkOrderCloseOrderJob.class, "工单关闭");
        this.setMultiInstance(true);
    }

    @Override
    public void executeMesJob(JobExecutionContext context, ApplicationProperties applicationProperties) {
        try {
            String jobParam = this.getJobParam();

            if (StringUtils.isBlank(jobParam)) {
                throw new IllegalArgumentException("job参数为空，请检查参数");
            }
            String[] organizeCodeList = jobParam.split(",");
            LOGGER.info("工单关闭开始 -----start");
            String userName = "CLOSE_JOB";

            for (String organizeCode : organizeCodeList) {
                mesWorkOrderService.doCloseUnSortOrder(organizeCode, userName);
            }
            LOGGER.info("工单关闭开始结束 ----- end");

        } catch (Exception e) {
            LOGGER.error("工单关闭任务结束e:{}", e.toString());
        }
    }

}
