package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCustSoftInfoService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesCustSortInfo;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2024/6/2 20:39
 * @Modify:
 **/
@Service
public class MesCustSoftInfoServiceImpl extends BaseMesService<MesCustSortInfo> implements IMesCustSoftInfoService {
    @Override
    public List<MesCustSortInfo> queryCustSortInfoList(String custCode, String custOrganizeCode, String infoPointCode, String organizeCode, List<String> custPartNoList) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(custCode,"custCode", ddlPackBean);
        DdlPreparedPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(),"serviceFlag", ddlPackBean);
        DdlPreparedPack.getStringEqualPack(custOrganizeCode, "custOrganizeCode", ddlPackBean);
        DdlPreparedPack.getStringEqualPack(infoPointCode, "infoPointCode", ddlPackBean);
        DdlPreparedPack.getInPackList(custPartNoList,"custPartNo", ddlPackBean);
        return baseRDao.findByHqlWhere(ddlPackBean);
    }

    @Override
    public List<MesCustSortInfo> queryAllCustSortInfoList(String organizeCode) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(),"serviceFlag", ddlPackBean);
        return baseRDao.findByHqlWhere(ddlPackBean);
    }

    @Override
    public void updateCustSortInfo(MesCustSortInfo custSortInfo) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(custSortInfo.getOrganizeCode());
        DdlPreparedPack.getNumEqualPack(custSortInfo.getId(),"id",ddlPackBean);
        baseRDao.updateByPropertiesNoSync(new String[]{"serviceFlag","modifyUser","modifyDatetime"},new Object[]{CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValue(),"edi", TimeTool.getNowTime(true)},ddlPackBean);

    }

    @Override
    public void updateMsgCustSortInfo(MesCustSortInfo custSortInfo) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(custSortInfo.getOrganizeCode());
        DdlPreparedPack.getNumEqualPack(custSortInfo.getId(),"id",ddlPackBean);
        baseRDao.updateByProperties(new String[]{"description","modifyUser","modifyDatetime"},new Object[]{custSortInfo.getDescription(),"edi", TimeTool.getNowTime(true)},ddlPackBean);

    }
}
