package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCutSchemeEquipmentDetailService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesCutSchemeEquipmentDetail;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Description :
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/18 17:04
 * @Modify:
 **/
@Slf4j
@Service
public class MesCutSchemeEquipmentDetailServiceImpl extends BaseMesService<MesCutSchemeEquipmentDetail> implements IMesCutSchemeEquipmentDetailService {

    @Override
    protected void setPackQueryBean(MesCutSchemeEquipmentDetail bean, DdlPackBean packBean) {
        Long pid = bean.getPid();
        if (pid != null) {
            DdlPreparedPack.getNumEqualPack(pid, "pid", packBean);
        }
    }

    @Override
    protected void onInsertBean(MesCutSchemeEquipmentDetail item) {
        ValidatorBean.checkNotNull(item.getName(), "名称不能为空");
        ValidatorBean.checkNotNull(item.getValue(), "值不能为空");

    }

    @Override
    protected void onUpdateBean(MesCutSchemeEquipmentDetail item) {
        ValidatorBean.checkNotNull(item.getId(), "id不能为空");
        ValidatorBean.checkNotNull(item.getName(), "名称不能为空");
        ValidatorBean.checkNotNull(item.getValue(), "值不能为空");
    }
}
