package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCutSchemeEquipmentProcessParamService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesCutSchemeEquipmentProcessParam;
import cn.estsh.i3plus.pojo.mes.repository.MesEquipmentRepository;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Description :
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/18 16:51
 * @Modify:
 **/
@Slf4j
@Service
public class MesCutSchemeEquipmentProcessParamServiceImpl extends BaseMesService<MesCutSchemeEquipmentProcessParam> implements IMesCutSchemeEquipmentProcessParamService {

    @Autowired
    private MesEquipmentRepository mesEquipmentRepository;

    @Override
    protected void setPackQueryBean(MesCutSchemeEquipmentProcessParam bean, DdlPackBean packBean) {
        Long pid = bean.getPid();
        if (pid != null) {
            DdlPreparedPack.getNumEqualPack(pid, "pid", packBean);
        }
    }

    @Override
    protected void onInsertBean(MesCutSchemeEquipmentProcessParam item) {
        ValidatorBean.checkNotNull(item.getEquipmentCode(), "设备代码不能为空");
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getEquipmentCode(), "equipmentCode", ddlPackBean);
        if(!mesEquipmentRepository.isExitByHql(ddlPackBean)){
            MesException.throwMesBusiException("设备代码不存在", item.getEquipmentCode());
        }
    }

    @Override
    protected void onUpdateBean(MesCutSchemeEquipmentProcessParam item) {
        ValidatorBean.checkNotNull(item.getId(), "id不能为空");
        ValidatorBean.checkNotNull(item.getEquipmentCode(), "设备代码不能为空");
    }
}
