package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCutSchemeEquipmentService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesCutSchemeEquipment;
import cn.estsh.i3plus.pojo.mes.repository.MesEquipmentRepository;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

/**
 * @Description :
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/18 15:55
 * @Modify:
 **/
@Slf4j
@Service
public class MesCutSchemeEquipmentServiceImpl extends BaseMesService<MesCutSchemeEquipment> implements IMesCutSchemeEquipmentService {

    @Autowired
    private MesEquipmentRepository mesEquipmentRepository;

    @Override
    protected void onInsertBean(MesCutSchemeEquipment item) {
        ValidatorBean.checkNotNull(item.getCutCode(), "裁片代码不能为空");
        ValidatorBean.checkNotNull(item.getEquipmentCode(), "设备代码不能为空");
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getEquipmentCode(), "equipmentCode", ddlPackBean);
        if(!mesEquipmentRepository.isExitByHql(ddlPackBean)){
            throw new RuntimeException("设备代码不存在");
        }
    }

    @Override
    protected void onUpdateBean(MesCutSchemeEquipment item) {
        ValidatorBean.checkNotNull(item.getId(), "主键不能为空");
        ValidatorBean.checkNotNull(item.getCutCode(), "裁片代码不能为空");
        ValidatorBean.checkNotNull(item.getEquipmentCode(), "设备代码不能为空");
    }

    @Override
    protected void setPackQueryBean(MesCutSchemeEquipment bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getCutCode(), "cutCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getEquipmentCode(), "equipmentCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getEquipmentName(), "equipmentName", packBean);
    }
}
