package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCutSchemeMaterialService;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesCutSchemeMaterial;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Description :
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/18 13:37
 * @Modify:
 **/
@Slf4j
@Service
public class MesCutSchemeMaterialServiceImpl extends BaseMesService<MesCutSchemeMaterial> implements IMesCutSchemeMaterialService {


    @Override
    protected void onInsertBean(MesCutSchemeMaterial item) {
        ValidatorBean.checkNotNull(item.getCutCode(), "裁片方案代码不能为空");
    }


    @Override
    protected void onUpdateBean(MesCutSchemeMaterial item) {
        ValidatorBean.checkNotNull(item.getId(), "id不能为空");
        ValidatorBean.checkNotNull(item.getCutCode(), "裁片方案代码不能为空");
    }

    @Override
    protected void setPackQueryBean(MesCutSchemeMaterial bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getCutCode(), MesExtConstWords.CUT_CODE, packBean);
    }
}
