package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCutSchemeService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.BeanMapUtilsExt;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.*;
import cn.estsh.i3plus.pojo.mes.repository.MesWorkCenterRepository;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
@Slf4j
public class MesCutSchemeService extends BaseMesService<MesCutScheme> implements IMesCutSchemeService {

    @Autowired
    private MesWorkCenterRepository workCenterRepository;

    protected void setPackQueryBean(MesCutScheme bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getWorkCenterCode(), MesExtConstWords.WORK_CENTER_CODE, packBean);
        DdlPreparedPack.getStringLikerPack(bean.getCutCode(), MesExtConstWords.CUT_CODE, packBean);
        DdlPreparedPack.getStringEqualPack(bean.getCutName(), MesExtConstWords.CUT_NAME, packBean);
    }

    @Override
    public void setBeanModel(List<MesCutScheme> list) {
        if(CollectionUtils.isEmpty(list)){
            return;
        }
        List<String> workCenterCodeList = list.stream().map(MesCutScheme::getWorkCenterCode).filter(t -> !StringUtils.isEmpty(t)).distinct().collect(Collectors.toList());
        Map<String, MesWorkCenter> beanMap = CollectionUtils.isEmpty(workCenterCodeList) ? null : BeanMapUtilsExt.getBeanMap(workCenterRepository, MesExtConstWords.WORK_CENTER_CODE, list.iterator().next().getOrganizeCode(), workCenterCodeList);
        if(!CollectionUtils.isEmpty(beanMap)){
            list.forEach(t->{
                if (beanMap.containsKey(t.getWorkCenterCode())) {
                    t.setWorkCenterName(beanMap.get(t.getWorkCenterCode()).getWorkCenterName());
                }
            });
        }
    }

    protected void onInsertBean(MesCutScheme item) {
        ValidatorBean.checkNotNull(item.getCutCode(),"裁片方案代码不能为空");
        ValidatorBean.checkNotNull(item.getCutName(),"裁片方案名称不能为空");
    }


    protected void onUpdateBean(MesCutScheme item) {

        // 数据校验
        //ValidatorBean.checkNotNull(item.getDefectTypeCode(), "缺陷类型代码不能为空");
        //ValidatorBean.checkNotNull(item.getDefectTypeName(), "缺陷类型名称不能为空");
        //
        //DdlPackBean packBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        //DdlPreparedPack.getStringEqualPack(item.getDefectTypeCode(), "defectTypeCode", packBean);
        //DdlPreparedPack.getNumNOEqualPack(item.getId(), "id", packBean);
        //boolean flg = baseRDao.isExitByHql(packBean);
        //if (flg) {
        //    throw ImppExceptionBuilder.newInstance()
        //            .setSystemID(CommonEnumUtil.SOFT_TYPE.MES.getCode())
        //            .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
        //            .setErrorDetail("【%s】缺陷类型代码已经存在，请检查数据", item.getDefectTypeCode())
        //            .build();
        //}
    }
    @Override
    public void validateImport(List<MesCutScheme> beanList) {

        //for (MesCutScheme item : beanList) {
        //    // 数据校验
        //    ValidatorBean.checkNotNull(item.getDefectTypeCode(), "缺陷类型代码不能为空");
        //    ValidatorBean.checkNotNull(item.getDefectTypeName(), "缺陷类型名称不能为空");
        //
        //    DdlPackBean packBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        //    DdlPreparedPack.getStringEqualPack(item.getDefectTypeCode(), "defectTypeCode", packBean);
        //    boolean flg = baseRDao.isExitByHql(packBean);
        //    if (flg) {
        //        throw ImppExceptionBuilder.newInstance()
        //                .setSystemID(CommonEnumUtil.SOFT_TYPE.MES.getCode())
        //                .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
        //                .setErrorDetail("【%s】缺陷类型代码已经存在，请检查数据", item.getDefectTypeCode())
        //                .build();
        //    }
        //}
    }
}
