package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesEquipmentProdParamCfgService;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipmentProdParamCfg;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description : 设备加工参数维护
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/14 14:05
 * @Modify:
 **/
@Service
@Slf4j
public class MesEquipmentProdParamCfgServiceImpl extends BaseMesService<MesEquipmentProdParamCfg> implements IMesEquipmentProdParamCfgService {

    @Override
    protected void setPackQueryBean(MesEquipmentProdParamCfg bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getCavityCode(),"cavityCode",packBean);
//        DdlPreparedPack.getStringEqualPack(bean.getCavityCode(),"pid",packBean);
        DdlPreparedPack.getNumEqualPack(bean.getSourceId(),"sourceId",packBean);
    }

    @Override
    protected void onInsertBean(MesEquipmentProdParamCfg item) {
        item.setDataSource(MesExtEnumUtil.EQUIPMENT_PROD_PARAM_DATA_SOURCE.DATA_SOURCE30.getValue());
    }

    @Override
    protected void onUpdateBean(MesEquipmentProdParamCfg item) {
    }
    @Override
    public void validateImport(List<MesEquipmentProdParamCfg> beanList) {

        for (MesEquipmentProdParamCfg item : beanList) {
            // 数据校验
            ValidatorBean.checkNotNull(item.getSourceId(), "数据来源ID不能为空");
            ValidatorBean.checkNotNull(item.getEquipmentCode(), "设备代码不能为空");

        }
    }
}
