package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesPartTypePictureService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesPartTypePicture;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class MesPartTypePictureServiceImpl extends BaseMesService<MesPartTypePicture> implements IMesPartTypePictureService {

    @Override
    protected void setPackQueryBean(MesPartTypePicture bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getPartTypeCode(), "partTypeCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getPartTypeName(), "partTypeName", packBean);
    }

    @Override
    protected void onInsertBean(MesPartTypePicture item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getPartTypeCode(), "零件类型代码不能为空");

        DdlPackBean packBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getPartTypeCode(), "partTypeCode", packBean);
        if (baseRDao.isExitByHql(packBean)) {
            MesException.throwMesBusiException("【%s】零件类型代码已经存在，请检查数据", item.getPartTypeCode());
        }
    }

    @Override
    protected void onUpdateBean(MesPartTypePicture item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getPartTypeCode(), "零件类型代码不能为空");

        DdlPackBean packBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getPartTypeCode(), "partTypeCode", packBean);
        DdlPreparedPack.getNumNOEqualPack(item.getId(), "id", packBean);
        if (baseRDao.isExitByHql(packBean)) {
            MesException.throwMesBusiException("【%s】零件类型代码已经存在，请检查数据", item.getPartTypeCode());
        }
    }

}