package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesProdRuleSortCfgService;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.platform.common.exception.ImppExceptionEnum;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesProdRuleSortCfg;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Slf4j
public class MesProdRuleSortCfgService extends BaseMesService<MesProdRuleSortCfg> implements IMesProdRuleSortCfgService {

    protected void setPackQueryBean(MesProdRuleSortCfg bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getWorkCenterCode(), MesExtConstWords.WORK_CENTER_CODE, packBean);
        DdlPreparedPack.getStringEqualPack(bean.getWorkCellCode(), MesExtConstWords.WORK_CELL_CODE, packBean);
        DdlPreparedPack.getStringEqualPack(bean.getProcessCode(), MesExtConstWords.PROCESS_CODE, packBean);
        DdlPreparedPack.getStringEqualPack(bean.getCraftCode(), MesExtConstWords.CRAFT_CODE, packBean);
        DdlPreparedPack.getStringLikerPack(bean.getAssemblyPartNo(), MesExtConstWords.ASSEMBLY_PART_NO, packBean);
        DdlPreparedPack.getStringLikerPack(bean.getAssemblyPartName(), MesExtConstWords.ASSEMBLY_PART_NAME, packBean);
        DdlPreparedPack.getStringLikerPack(bean.getAssemblyPartNo(), MesExtConstWords.ASSEMBLY_PART_NO, packBean);
        DdlPreparedPack.getStringLikerPack(bean.getVehicleNo(), MesExtConstWords.VEHICLE_NO, packBean);
        DdlPreparedPack.getStringLikerPack(bean.getVehicleClassNo(), MesExtConstWords.VEHICLE_CLASS_NO, packBean);

    }

    @Override
    public MesProdRuleSortCfg insert(MesProdRuleSortCfg bean) {
        //插入前构造并校验数据
        onInsertBean(bean);

        bean = baseRDao.insert(bean);
        return bean;
    }

    protected void onInsertBean(MesProdRuleSortCfg item) {
        ValidatorBean.checkNotNull(item.getWorkCenterCode(), "产线不能为空");
        ValidatorBean.checkNotNull(item.getWorkCellCode(), "工位不能为空");
        ValidatorBean.checkNotNull(item.getProcessCode(), "工序不能为空");
        ValidatorBean.checkNotNull(item.getCraftCode(), "工艺不能为空");
        ValidatorBean.checkNotNull(item.getEquipmentCode(), "设备不能为空");
        ValidatorBean.checkNotNull(item.getAssemblyPartNo(), "零件号不能为空");
        ValidatorBean.checkNotNull(item.getProcessSeq(), "工艺顺序号不能为空");
        ValidatorBean.checkNotNull(item.getRouteSeq(), "装备顺序号不能为空");
        ValidatorBean.checkNotNull(item.getMatchType(), "装配件条码确认方式不能为空");
        ValidatorBean.checkNotNull(item.getReportType(), "汇报方式不能为空");
    }

    protected void onUpdateBean(MesProdRuleSortCfg item) {
        onInsertBean(item);
    }

    @Override
    public void validateImport(List<MesProdRuleSortCfg> beanList) {

        for (MesProdRuleSortCfg item : beanList) {
            onInsertBean(item);
        }
    }


}
