package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesProductOffLineService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.base.util.StringUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesProductOffLine;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description : 生产汇报
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/10 14:40
 * @Modify:
 **/
@Service
public class MesProductOffLineServiceImpl extends BaseMesService<MesProductOffLine> implements IMesProductOffLineService {

    @Override
    public List<MesProductOffLine> findMesProductOffLineByProductSn(String productSn, String organizeCode) {
        if(StringUtil.isEmpty(productSn) || StringUtil.isEmpty(organizeCode)){
            return null;
        }
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(productSn,"reportSn",packBean);
        DdlPreparedPack.getNumEqualPack(MesExtEnumUtil.REPORT_TYPE.REPORT.getValue(),"reportType",packBean);
        return baseRDao.findByHqlWhere(packBean);
    }

    @Override
    public List<MesProductOffLine> findMesProductOffLineByRecordId(String recordId, String organizeCode) {
        if(StringUtil.isEmpty(recordId) || StringUtil.isEmpty(organizeCode)){
            return null;
        }
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(recordId,"productionRecordId",packBean);
        DdlPreparedPack.getNumEqualPack(MesExtEnumUtil.REPORT_TYPE.REPORT.getValue(),"reportType",packBean);
        return baseRDao.findByHqlWhere(packBean);
    }
}
