package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesRawPackageDetailService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesRawPackageDetail;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.UUID;

/**
 * @Description : 原材料容器明细
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/7/26 10:56
 * @Modify:
 **/
@Service
@Slf4j
public class MesRawPackageDetailServiceImpl extends BaseMesService<MesRawPackageDetail> implements IMesRawPackageDetailService {

    protected void setPackQueryBean(MesRawPackageDetail bean, DdlPackBean packBean) {
        DdlPreparedPack.getNumEqualPack(bean.getPid(), "pid", packBean);
        DdlPreparedPack.getNumEqualPack(bean.getPackageType(), "packageType", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getEquipCode(), "equipCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getPackageSn(), "packageSn", packBean);
    }

    protected void onInsertBean(MesRawPackageDetail item) {
        //数据校验
        checkData(item);
        //生成fid
        item.setFid(UUID.randomUUID().toString());
    }

    protected void onUpdateBean(MesRawPackageDetail item) {
        //数据校验
        checkData(item);
    }

    private void checkData(MesRawPackageDetail item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getPid(), "pid不能为空");
        ValidatorBean.checkNotNull(item.getPackageType(), "容器类型不能为空");
        ValidatorBean.checkNotNull(item.getPackageSn(), "容器条码不能为空");
    }
}
