package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesRawPackageService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesRawPackage;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.UUID;

/**
 * @Description : 原材料容器
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/7/26 10:58
 * @Modify:
 **/
@Service
@Slf4j
public class MesRawPackageServiceImpl extends BaseMesService<MesRawPackage> implements IMesRawPackageService {

    protected void setPackQueryBean(MesRawPackage bean, DdlPackBean packBean) {
        DdlPreparedPack.getNumEqualPack(bean.getPackageType(), "packageType", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getName(), "name", packBean);

    }

    protected void onInsertBean(MesRawPackage item) {
        //数据校验
        checkData(item);
        //生成fid
        item.setFid(UUID.randomUUID().toString());
    }

    protected void onUpdateBean(MesRawPackage item) {
        //数据校验
        checkData(item);
    }

    private void checkData(MesRawPackage item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getPackageType(), "容器类型");
        ValidatorBean.checkNotNull(item.getName(), "容器名称");
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getNumEqualPack(item.getPackageType(), "packageType", packBean);
        DdlPreparedPack.getNumNOEqualPack(item.getId(), "id", packBean);
        if (baseRDao.isExitByHql(packBean)) {
            MesException.throwMesBusiException("容器类型【%s】已存在", item.getPackageType());
        }
    }
}
