package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesRecyclablePackagePartService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.recyclablepackage.MesRecyclablePackagePart;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

/**
 * @Description :
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/14 13:45
 * @Modify:
 **/
@Slf4j
@Service
public class MesRecyclablePackagePartServiceImpl extends BaseMesService<MesRecyclablePackagePart> implements IMesRecyclablePackagePartService {


    @Override
    protected void onInsertBean(MesRecyclablePackagePart item) {
        ValidatorBean.checkNotNull(item.getPartNo(), "零件号不能为空");
        ValidatorBean.checkNotNull(item.getPackageTypeCode(), "包类型不能为空");
        DdlPackBean seriesPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getPartNo(), "partNo", seriesPackBean);
        if (baseRDao.isExitByHql(seriesPackBean)) {
            MesException.throwMesBusiException("零件号【%s】已存在", item.getPartNo());
        }
    }

    @Override
    protected void setPackQueryBean(MesRecyclablePackagePart bean, DdlPackBean packBean) {
        String packageTypeCode = bean.getPackageTypeCode();
        if (!StringUtils.isEmpty(packageTypeCode)) {
            DdlPreparedPack.getStringLikerPack(packageTypeCode, "packageTypeCode", packBean);
        }
        String partNo = bean.getPartNo();
        if (!StringUtils.isEmpty(partNo)) {
            DdlPreparedPack.getStringLikerPack(partNo, "partNo", packBean);
        }
    }

    @Override
    protected void onUpdateBean(MesRecyclablePackagePart item) {
        ValidatorBean.checkNotNull(item.getPartNo(), "零件号不能为空");
        ValidatorBean.checkNotNull(item.getPackageTypeCode(), "包类型不能为空");
        DdlPackBean seriesPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getPartNo(), "partNo", seriesPackBean);
        DdlPreparedPack.getNumNOEqualPack(item.getId(),"id",seriesPackBean);
        if (baseRDao.isExitByHql(seriesPackBean)) {
            MesException.throwMesBusiException("零件号【%s】已存在", item.getPartNo());
        }
    }

}
