package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesRecyclablePackageService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.recyclablepackage.MesRecyclablePackage;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

/**
 * @Description :
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/14 10:03
 * @Modify:
 **/
@Slf4j
@Service
public class MesRecyclablePackageServiceImpl extends BaseMesService<MesRecyclablePackage> implements IMesRecyclablePackageService {

    @Override
    protected void onInsertBean(MesRecyclablePackage item) {
        ValidatorBean.checkNotNull(item.getPackageTypeCode(), "包类型不能为空");
        ValidatorBean.checkNotNull(item.getPackageSn(), "包条码不能为空");
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getPackageSn(), "packageSn", ddlPackBean);
        if (baseRDao.isExitByHql(ddlPackBean)) {
            MesException.throwMesBusiException("回收包装条码【%s】已存在", item.getPackageSn());
        }
    }

    @Override
    protected void onUpdateBean(MesRecyclablePackage item) {
        ValidatorBean.checkNotNull(item.getId(), "id不能为空");
        ValidatorBean.checkNotNull(item.getPackageTypeCode(), "包类型不能为空");
        ValidatorBean.checkNotNull(item.getPackageSn(), "包条码不能为空");
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getPackageSn(), "packageSn", ddlPackBean);
        DdlPreparedPack.getNumNOEqualPack(item.getId(), "id", ddlPackBean);
        if (baseRDao.isExitByHql(ddlPackBean)) {
            MesException.throwMesBusiException("回收包装条码【%s】已存在", item.getPackageSn());
        }
    }

    @Override
    protected void setPackQueryBean(MesRecyclablePackage bean, DdlPackBean packBean) {
        String packageTypeCode = bean.getPackageTypeCode();
        if (!StringUtils.isEmpty(packageTypeCode)) {
            DdlPreparedPack.getStringLikerPack(packageTypeCode, "packageTypeCode", packBean);
        }
        String packageSn = bean.getPackageSn();
        if (!StringUtils.isEmpty(packageSn)) {
            DdlPreparedPack.getStringLikerPack(packageSn, "packageSn", packBean);
        }
    }


}
