package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesStationService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesStation;
import cn.estsh.i3plus.pojo.mes.repository.MesEquipmentRepository;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Description :
 * @Reference :
 * @Author : PZJ
 * @CreateDate : 2024/9/20 14:46
 * @Modify:
 **/
@Service
@Slf4j
public class MesStationServiceImpl extends BaseMesService<MesStation> implements IMesStationService {

    @Autowired
    private MesEquipmentRepository mesEquipmentRepository;
    @Override
    protected void setPackQueryBean(MesStation bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getStation(), "station", packBean);
        DdlPreparedPack.getNumEqualPack(bean.getStationType(), "stationType", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getEquipmentCode(), "equipmentCode", packBean);
    }

    @Override
    protected void onInsertBean(MesStation item) {
        ValidatorBean.checkNotNull(item.getEquipmentCode(),"设备代码不能为空");
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getEquipmentCode(),"equipmentCode",ddlPackBean);
        if (!mesEquipmentRepository.isExitByHql(ddlPackBean)){
            MesException.throwBusiException("设备代码不存在");
        }
    }

    @Override
    protected void onUpdateBean(MesStation item) {
        ValidatorBean.checkNotNull(item.getId(),"主键不能为空");
        ValidatorBean.checkNotNull(item.getStation(),"站点不能为空");
        ValidatorBean.checkNotNull(item.getStationType(),"站点类型不能为空");
        ValidatorBean.checkNotNull(item.getEquipmentCode(),"设备代码不能为空");
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getEquipmentCode(),"equipmentCode",ddlPackBean);
        DdlPreparedPack.getNumNOEqualPack(item.getId(),"id",ddlPackBean);
        if (!mesEquipmentRepository.isExitByHql(ddlPackBean)){
            MesException.throwBusiException("设备代码不存在");
        }
    }
}
