package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkOrderAssemblyService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.base.util.StringUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderAssembly;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description : 工单装配件
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/9/19 16:44
 * @Modify:
 **/
@Service
@Slf4j
public class MesWorkOrderAssemblyServiceImpl extends BaseMesService<MesWorkOrderAssembly> implements IMesWorkOrderAssemblyService {

    @Override
    protected void setPackQueryBean(MesWorkOrderAssembly bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getWorkOrderNo(), "workOrderNo", packBean);
        DdlPreparedPack.getOrderByPack(new Object[]{CommonEnumUtil.ASC_OR_DESC.ASC.getValue(),CommonEnumUtil.ASC_OR_DESC.ASC.getValue()}, new String[]{"processSeq","routeSeq"}, packBean);
    }

    @Override
    public List<MesWorkOrderAssembly> findMesWorkOrderAssembly(String workOrderNo, String organizeCode) {
        if(StringUtil.isEmpty(workOrderNo) || StringUtil.isEmpty(organizeCode)) return null;
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workOrderNo,"workOrderNo",packBean);
        return baseRDao.findByHqlWhere(packBean);
    }

}
