package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkOrderPartService;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.base.util.StringUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderPart;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.util.CollectionUtils;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description : 工单零件
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/9/19 16:44
 * @Modify:
 **/
@Service
@Slf4j
public class MesWorkOrderPartServiceImpl extends BaseMesService<MesWorkOrderPart> implements IMesWorkOrderPartService {

    @Override
    protected void setPackQueryBean(MesWorkOrderPart bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getWorkOrderNo(), "workOrderNo", packBean);
    }

    @Override
    public List<MesWorkOrderPart> findMesWorkOrderPart(String workOrderNo, String organizeCode) {
        if(StringUtil.isEmpty(workOrderNo) || StringUtil.isEmpty(organizeCode)) return null;
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workOrderNo,"workOrderNo",packBean);
        return baseRDao.findByHqlWhere(packBean);
    }

    @Override
    public List<MesWorkOrderPart> findMesWorkOrderPart(List<String> workOrderNoList, String organizeCode) {
        if (CollectionUtils.isEmpty(workOrderNoList) || StringUtil.isEmpty(organizeCode)) return null;
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        if (workOrderNoList.size() == MesExtConstWords.ONE) {
            DdlPreparedPack.getStringEqualPack(workOrderNoList.get(MesExtConstWords.ZERO), MesExtConstWords.WORK_ORDER_NO, packBean);
        } else {
            DdlPreparedPack.getInPackList(workOrderNoList, MesExtConstWords.WORK_ORDER_NO, packBean);
        }
        return baseRDao.findByHqlWhere(packBean);
    }
}
