package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkOrderToWmsService;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.platform.common.tool.MathOperation;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.base.util.StringUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesBom;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrder;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderToWms;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description : 工单发送给WMS数据
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/18 19:58
 * @Modify:
 **/
@Service
@Slf4j
public class MesWorkOrderToWmsServiceImpl extends BaseMesService<MesWorkOrderToWms> implements IMesWorkOrderToWmsService {

    @Override
    public List<MesWorkOrderToWms> saveMesWorkOrderToWms(MesWorkOrder mesWorkOrder, List<MesBom> mesBomList,String userName,boolean flag) {
        List<MesWorkOrderToWms> mesWorkOrderToWmsList = new ArrayList<>();
        MesWorkOrderToWms mesWorkOrderToWms = null;
        for (MesBom mesBom : mesBomList) {
            mesWorkOrderToWms = new MesWorkOrderToWms();
            BeanUtils.copyProperties(mesWorkOrder, mesWorkOrderToWms, MesExtConstWords.ID);
            mesWorkOrderToWms.setUnit(mesBom.getUnit());
            mesWorkOrderToWms.setFlag(flag ? CommonEnumUtil.VALID : CommonEnumUtil.FALSE);
            mesWorkOrderToWms.setItemPartNo(mesBom.getItemPartNo());
            mesWorkOrderToWms.setItemPartName(mesBom.getItemPartName());
            mesWorkOrderToWms.setItemUnit(mesBom.getItemUnit());
            mesWorkOrderToWms.setItemQty(MathOperation.mul(mesWorkOrder.getQty(), mesBom.getItemQty()));
            ConvertBean.serviceModelInitialize(mesWorkOrderToWms, userName);
            mesWorkOrderToWmsList.add(mesWorkOrderToWms);
        }
        return mesWorkOrderToWmsList;
    }

    @Override
    public List<MesWorkOrderToWms> findMesWorkOrderToWms(String workOrderNo, String organizeCode) {
        if(StringUtil.isEmpty(workOrderNo) || StringUtil.isEmpty(organizeCode)) return null;
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(workOrderNo,"workOrderNo",packBean);
        return baseRDao.findByHqlWhere(packBean);
    }
}
