package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.ext.mes.api.base.IMesCustomerPartService;
import cn.estsh.i3plus.ext.mes.api.busi.IMesOfflineService;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base.MesPartProdGroupDetailService;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base.MesPartProdGroupService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.*;
import cn.estsh.i3plus.pojo.mes.repository.MesPartPullDetailRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesPartPullRepository;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

@Service
public class MesOfflineServiceImpl implements IMesOfflineService {

    @Autowired
    private MesSortRuleCfgOfflineServiceImpl cfgOfflineService;


    @Autowired
    private MesPartProdGroupService partProdGroupService;

    @Autowired
    private MesPartProdGroupDetailService partProdGroupDetailService;

   @Autowired
   private MesPartPullRepository partPullRao;

   @Autowired
   private MesPartPullDetailRepository partPullDetailRao;

    @Override
    public void doCreateSortRuleCfgOfflineData(String organizeCode,List<String> groupCodeList) {
        //清空表
        cfgOfflineService.deleteSortRuleOffline(organizeCode);
        //2.查询零件生产组
        List<MesPartProdGroup> partProdGroupList = partProdGroupService.findMesPartProdGroups(organizeCode,groupCodeList);
        for (MesPartProdGroup mesPartProdGroup : partProdGroupList) {
            String partProdGroupCode = mesPartProdGroup.getPartProdGroupCode();
            DdlPackBean detailPartProdDetailPackBean = DdlPackBean.getDdlPackBean(organizeCode);
            DdlPreparedPack.getStringEqualPack(partProdGroupCode,"partProdGroupCode",detailPartProdDetailPackBean);
            List<MesPartProdGroupDetail> detailList = partProdGroupDetailService.findAll(detailPartProdDetailPackBean);
            //3.根据客户零件表中的erp零件，是总成零件号;遍历每个客户零件号生成sortRuleCfgOff表
            for (MesPartProdGroupDetail detail : detailList) {
                String erpPartNo = detail.getPartNo();
                String productPartNo = StringUtils.isBlank(detail.getProductPartNo()) ? erpPartNo : detail.getProductPartNo();
                cfgOfflineService.doCreateSortRuleOffline(detail.getCustPartNo(), erpPartNo,productPartNo,organizeCode,mesPartProdGroup,detail);
            }
        }
   
        //4.总成零件号打散bom

        //5.打散的bom 获取排序加工规则

        //6.装配件获取的三种条件

        //7.保存到离线表中

    }

    @Override
    public void doCreatePullOrderOfflineData(String organizeCode, List<String> pullCodeList,List<String> partProdCodeList) {
        //拉动组和生产零件都是按照产线配置的 一对一
        //清空表
        cfgOfflineService.deletePullOffline(organizeCode);
        cfgOfflineService.deletePullDetailOffline(organizeCode);
        //2.查询零件生产组
        List<MesPartProdGroup> partProdGroupList = partProdGroupService.findMesPartProdGroups(organizeCode,partProdCodeList);
        //3.获取拉动组
        DdlPackBean partPullPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(pullCodeList,"pullCode",partPullPackBean);
        List<MesPartPull> mesPartPullList = partPullRao.findByHqlWhere(partPullPackBean);
        Map<String, MesPartPull> partPullMap = mesPartPullList.stream().collect(Collectors.toMap(MesPartPull::getWorkCenterCode, Function.identity()));
        //4.获取拉动组的详情
        DdlPackBean partPullDetailPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(pullCodeList,"pullCode",partPullDetailPackBean);
        List<MesPartPullDetail> mesPartPullDetailList = partPullDetailRao.findByHqlWhere(partPullDetailPackBean);
        Map<String, List<MesPartPullDetail>> detailMapList = mesPartPullDetailList.stream().collect(Collectors.groupingBy(MesPartPullDetail::getPullCode));
        //5.遍历零件生产组
        for (MesPartProdGroup mesPartProdGroup : partProdGroupList) {
            String partProdGroupCode = mesPartProdGroup.getPartProdGroupCode();
            DdlPackBean detailPartProdDetailPackBean = DdlPackBean.getDdlPackBean(organizeCode);
            DdlPreparedPack.getStringEqualPack(partProdGroupCode,"partProdGroupCode",detailPartProdDetailPackBean);
            List<MesPartProdGroupDetail> detailList = partProdGroupDetailService.findAll(detailPartProdDetailPackBean);
            //3.根据客户零件表中的erp零件，是总成零件号;遍历每个客户零件号生成sortRuleCfgOff表
            for (MesPartProdGroupDetail detail : detailList) {
                String erpPartNo = detail.getPartNo();
                String productPartNo = StringUtils.isBlank(detail.getProductPartNo()) ? erpPartNo : detail.getProductPartNo();
                MesPartPull mesPartPull = partPullMap.get(mesPartProdGroup.getWorkCenterCode());
                List<MesPartPullDetail> mesPartPullDetails = detailMapList.get(mesPartPull.getPullCode());
                if (mesPartPullDetails == null) {
                    continue;
                }
                cfgOfflineService.doCreatePullOffline(detail.getCustPartNo(), erpPartNo,productPartNo,organizeCode,mesPartProdGroup,detail,partPullMap.get(mesPartProdGroup.getWorkCenterCode()), mesPartPullDetails);
            }


        }
        

    }
}
