package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.ext.mes.api.base.IBaseMesService;
import cn.estsh.i3plus.ext.mes.api.busi.IMesPojoVersionService;
import cn.estsh.i3plus.ext.mes.api.busi.IMesSpotCheckOrderPartService;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base.BaseMesService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesPojoVersion;
import cn.estsh.i3plus.pojo.mes.bean.MesPojoVersionDetail;
import cn.estsh.i3plus.pojo.mes.bean.MesSpotCheckOrderPart;
import cn.estsh.i3plus.pojo.mes.repository.MesPojoVersionDetailRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesPojoVersionRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesSpotCheckOrderRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Description :版本记录
 * @Reference :
 * @Author : zxw
 * @CreateDate 2024/5/23 13:28
 * @Modify:
 **/
@Service
public class MesPojoVersionService extends BaseMesService<MesPojoVersion> implements IMesPojoVersionService {

    @Autowired
    private MesPojoVersionDetailRepository pojoVersionDetailRepository;

    protected void setPackQueryBean(MesPojoVersion bean, DdlPackBean packBean) {
        DdlPreparedPack.getNumEqualPack(bean.getBusiData(), "busiData", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getRefClass(), "refClass", packBean);
        DdlPreparedPack.getNumEqualPack(bean.getOperateType(), "operateType", packBean);
    }

    @Override
    public MesPojoVersionDetail getPojoVersionDetailByPojoVersionId(Long pojoVersionId) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean();
        DdlPreparedPack.getNumEqualPack(pojoVersionId,"pojoVersionId",ddlPackBean);
        return pojoVersionDetailRepository.getByProperty(ddlPackBean);
    }
}
