package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.report;

import cn.estsh.i3plus.ext.mes.api.busi.report.IMesInspectionProductDataReportService;
import cn.estsh.i3plus.ext.mes.apiservice.dao.report.IMesInspectionProductDataReportDao;
import cn.estsh.i3plus.ext.mes.pojo.model.report.MesInspectionProductDataAmountReportModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.common.PagerHelper;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.List;

@Service
@Slf4j
public class MesInspectionProductDataReportService implements IMesInspectionProductDataReportService {

    @Autowired
    private IMesInspectionProductDataReportDao inspectionProductDataReportDao;

    /**
     * 检验产品数据总报表
     * @param model 查询条件
     * @param pager 分页条件
     * @return
     */
    @Override
    public ListPager<MesInspectionProductDataAmountReportModel> queryInspectionProductDataAmountReport(MesInspectionProductDataAmountReportModel model, Pager pager) {
        pager = PagerHelper.getPager(pager, inspectionProductDataReportDao.queryInspectionProductDataAmountReportCount(model));
        List<MesInspectionProductDataAmountReportModel> resultList = inspectionProductDataReportDao.queryInspectionProductDataAmountReport(model, pager);

        if (!CollectionUtils.isEmpty(resultList)) {
            for (MesInspectionProductDataAmountReportModel result : resultList) {
                if (null == result) continue;
                if (!StringUtils.isEmpty(result.getFrontBack())) result.setFrontBackName(MesExtEnumUtil.DEFECT_ALARM_CONFIG_SIDES.valueOfDescription(result.getFrontBack()));
                if (!StringUtils.isEmpty(result.getInspectionStatus())) result.setInspectionStatusName(MesExtEnumUtil.PART_INSPECTION_STATUS.valueOfDescription(result.getInspectionStatus()));
                if (!StringUtils.isEmpty(result.getNcStatus())) result.setNcStatusName(MesExtEnumUtil.PART_INSPECTION_NC_STATUS.valueOfDescription(result.getNcStatus()));
                if (!StringUtils.isEmpty(result.getTaskStatus())) result.setTaskStatusName(MesExtEnumUtil.REWORK_TASK_STATUS.valueOfDescription(result.getTaskStatus()));
            }
        }

        return new ListPager<>(resultList, pager);
    }

}
