package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.webservice;


import cn.estsh.i3plus.ext.mes.apiservice.model.AssetInfo;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.busi.MaximoServiceImpl;
import cn.estsh.i3plus.ext.mes.pojo.model.MaximoParamModel;
import cn.estsh.impp.framework.boot.util.SpringContextsUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import java.util.Map;

@Component
@WebService(targetNamespace = "http://yfaiesb/services/ServiceSyncMaximoEquip")
public class WebServiceServer {
    public static final Logger LOGGER = LoggerFactory.getLogger(WebServiceServer.class);
    @WebMethod(action = "SyncMaximoEquip", operationName = "SyncMaximoEquip")
    public Map syncEquip(@WebParam(name = "info") AssetInfo assetInfo) {
        LOGGER.info("SyncMaximoEquip主数据:{}", assetInfo);
        MaximoParamModel maximoParamModel = new MaximoParamModel();
        maximoParamModel.setAssetNum(assetInfo.getASSETNUM());
        maximoParamModel.setStatus(assetInfo.getSTATUS());
        maximoParamModel.setSiteId(assetInfo.getSITEID());
        maximoParamModel.setFailureCode(assetInfo.getFAILURECODE());
        maximoParamModel.setDescription(assetInfo.getDESCRIPTION());
        MaximoServiceImpl bean = (MaximoServiceImpl)SpringContextsUtil.getBean("maximoServiceImpl");
        return bean.doAssetMainData(maximoParamModel);
    }


}