package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.webservice;

import cn.estsh.i3plus.ext.mes.apiservice.model.SpsInfo;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base.MesPullingOrderInfoService;
import cn.estsh.i3plus.pojo.base.util.StringUtil;
import cn.estsh.impp.framework.boot.util.SpringContextsUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description :soapUI调用 http://10.193.30.22:8300/i3plus/mes-service-spsEqu?wsdl
 * @Author :gsz
 * @Date 2024/8/30 9:18
 * @Modify
 **/

//@WebService(targetNamespace = "http://yfaiesb/services/ServiceSyncMaximoInstrument")
@WebService(targetNamespace = "http://tempuri.org/services/SyncSPSForEquipmentService")
public class WebServiceServerSPS {
    public static final Logger LOGGER = LoggerFactory.getLogger(WebServiceServerSPS.class);

    @WebMethod(action = "SyncSPSForEquipmentService", operationName = "SyncSPSForEquipmentService")
    public Map syncSPSForEquipment(@WebParam(name = "info") SpsInfo spsInfo) {
        LOGGER.info("syncSPSForEquipment主数据:{}", spsInfo);

        MesPullingOrderInfoService bean = (MesPullingOrderInfoService) SpringContextsUtil.getBean("mesPullingOrderInfoService");
        if (StringUtil.isEmpty(spsInfo.getOrganizeCode())) {
            Map resultMap = new HashMap();
            resultMap.put("success", false);
            String message = "SPS拉动数据已扫描数据为空，请检查拉动单数据";
            resultMap.put("message", message);
            return resultMap;
        }
        return  bean.doSPSForEquipment("","",spsInfo.getOrganizeCode());
//        return  bean.doSPSForEquipment(spsInfo.getAssemblyLine(),spsInfo.getPullingGroupCode(),spsInfo.getOrganizeCode());
    }

}
