package cn.estsh.i3plus.ext.mes.pojo.model;


import cn.estsh.i3plus.pojo.base.annotation.AnnoOutputColumn;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesShippingOrderManagement;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesShippingOrderManagementDetail;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import javax.persistence.Column;

@Data
public class MesShippingOrderManagementDetailModel {

    @ApiParam("物料号")
    private String partNo;

    @ApiParam("物料号")
    private String partName;

    @ApiParam("客户零件号")
    private String custPartNo;

    @ApiParam("计划发运数量")
    private Double planQty;

    @ApiParam("实际发运数量")
    private Integer actualQty;

    @ApiParam("计量单位")
    private String unit;

    @ApiParam("工厂代码")
    private String organizeCode;

    @ApiParam("发运单")
    private String shippingCode;

    @ApiParam("状态")
    @AnnoOutputColumn(refClass = MesExtEnumUtil.SHIPPING_ORDER_STATUS.class, refForeignKey = "value", value = "description")
    private Integer status;

    @ApiParam("客户排序信息序号")
    private Long custInfoSeq;

    @ApiParam("条码")
    private String barcode;

    @ApiParam("客户订单号")
    private String custOrderNo;

    @ApiParam("创建时间")
    private String createDatetime;

    @ApiParam("创建人")
    private String createUser;

    @ApiParam(value = "更新时间")
    private String modifyDatetime;

    @ApiParam(value = "更新人")
    private String modifyUser;

    @ApiParam("发运单类型")
    @AnnoOutputColumn(refClass = MesExtEnumUtil.SHIPPING_ORDER_TYPE.class, refForeignKey = "value", value = "description")
    private Integer shippingType;

    @ApiParam("客户代码")
    private String custCode;

    @ApiParam("客户名称")
    private String custName;

    @ApiParam("客户工厂代码")
    private String custOrganizeCode;

    @ApiParam("客户工厂名称")
    private String custOrganizeName;

    @ApiParam("开始扫描时间")
    private String startScanTime;

    @ApiParam("开始扫描时间(开始)")
    private String startScanTimeStart;

    @ApiParam("开始扫描时间(结束)")
    private String startScanTimeEnd;

    @ApiParam("结束扫描时间")
    private String endScanTime;

    @ApiParam("结束扫描时间(开始)")
    private String endScanTimeStart;

    @ApiParam("结束扫描时间(结束)")
    private String endScanTimeEnd;

    @ApiParam("发布时间")
    private String publishTime;

    @ApiParam("发布时间(开始)")
    private String publishTimeStart;

    @ApiParam("发布时间(结束)")
    private String publishTimeEnd;

    @ApiParam("累计打印次数")
    private Integer printCount;

    @ApiParam("最后打印用户")
    private String lastPrintUser;

    @ApiParam("最后打印时间")
    private String lastPrintTime;

    @ApiParam("发运组代码")
    private String shippingGroupCode;

    @ApiParam("发运组名称")
    private String shippingGroupName;

    @ApiParam("车系代码")
    private String carSerialCode;

    @ApiParam(value = "排序属性")
    public String orderByParam = "";

    @ApiParam(value = "排序类型，1 正序，2 倒序",example = "1")
    public Integer ascOrDesc;

    @ApiParam("明细id")
    private Long id;

    @ApiParam("明细状态")
    @AnnoOutputColumn(refClass = MesExtEnumUtil.SHIPPING_ORDER_DETAIL_SHIPPING_STATUS.class, refForeignKey = "value", value = "description")
    private Integer detailsStatus;

    /**
     * vin号
     */
    @ApiParam("vin号")
    private String vin;

    public MesShippingOrderManagementDetailModel(){
    }

    public MesShippingOrderManagementDetailModel(MesShippingOrderManagement m, MesShippingOrderManagementDetail d){
        this.shippingCode = m.getShippingCode();
        this.status = m.getStatus();
        this.detailsStatus = d.getStatus();
        this.custInfoSeq = d.getCustInfoSeq();
        this.partName = d.getPartName();
        this.partNo = d.getPartNo();
        this.barcode = d.getBarcode();
        this.custPartNo = d.getCustPartNo();
        this.planQty = d.getPlanQty();
        this.actualQty = d.getActualQty();
        this.unit = d.getUnit();
        this.custOrderNo = m.getOrderCode();
        this.createDatetime = d.getCreateDatetime();
        this.createUser = d.getCreateUser();
        this.modifyDatetime = d.getModifyDatetime();
        this.modifyUser = d.getModifyUser();
        this.shippingType = m.getShippingType();
        this.custCode = m.getCustCode();
        this.custName = m.getCustName();
        this.custOrganizeCode = m.getCustOrganizeCode();
        this.custOrganizeName = m.getCustOrganizeName();
        this.startScanTime = m.getStartScanTime();
        this.endScanTime = m.getEndScanTime();
        this.publishTime = m.getPublishTime();
        this.printCount = m.getPrintCount();
        this.lastPrintTime = m.getLastPrintTime();
        this.lastPrintUser = m.getLastPrintUser();
        this.shippingGroupCode = m.getShippingGroupCode();
        this.shippingGroupName = m.getShippingGroupName();
        this.carSerialCode = d.getCarSerialCode();
        this.id = d.getId();
        this.vin = d.getVin();
    }

}
