package cn.estsh.i3plus.ext.mes.pojo.model.report;

import cn.estsh.i3plus.pojo.base.annotation.AnnoOutputColumn;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

/**
 * @Description : 设备数据查询报表-查询结果封装
 * @Reference :
 * @Author : logic
 * @CreateDate : 2024/6/15 13:23
 * @Modify:
 **/
@Data
@ApiModel("设备数据查询报表-查询结果封装")
public class MesDeviceDataQueryReportResultModel {

    @ApiParam(value = "ERP工厂号")
    @AnnoOutputColumn(name = "ERP工厂号")
    private String organizeCode;

    @ApiParam(value = "产线")
    @AnnoOutputColumn(name = "产线")
    private String workCenterCode;

    @ApiParam(value = "工位代码")
    @AnnoOutputColumn(name = "工位代码")
    private String workCellCode;

    @ApiParam(value = "工单")
    @AnnoOutputColumn(name = "工单")
    private String workOrderNo;

    @ApiParam(value = "主条码")
    @AnnoOutputColumn(name = "主条码")
    private String serialNumber;

    @ApiParam(value = "日志类型")
    private Integer logType;

    @ApiParam(value = "日志类型名称")
    @AnnoOutputColumn(name = "日志类型名称")
    private String logTypeName;

    @ApiParam(value = "日志内容")
    @AnnoOutputColumn(name = "日志内容")
    private String message;

    @ApiParam(value = "设备编号")
    @AnnoOutputColumn(name = "设备编号")
    private String equipmentCode;

    @ApiParam(value = "设备名称")
    @AnnoOutputColumn(name = "设备名称")
    private String equipmentName;

    @ApiParam(value = "创建时间")
    @AnnoOutputColumn(name = "创建时间")
    private String createDatetime;

    @ApiParam(value = "创建人")
    @AnnoOutputColumn(name = "创建人")
    private String createUser;

    @ApiParam(value = "更新时间")
    @AnnoOutputColumn(name = "更新时间")
    private String modifyDatetime;

    @ApiParam(value = "更新人")
    @AnnoOutputColumn(name = "更新人")
    private String modifyUser;

    public MesDeviceDataQueryReportResultModel(String organizeCode, String workCenterCode, String workCellCode,
                                               String workOrderNo, String serialNumber, Integer logType,
                                               String message, String equipmentCode,
                                               String equipmentName, String createDatetime, String createUser,
                                               String modifyDatetime, String modifyUser) {
        this.organizeCode = organizeCode;
        this.workCenterCode = workCenterCode;
        this.workCellCode = workCellCode;
        this.workOrderNo = workOrderNo;
        this.serialNumber = serialNumber;
        this.logType = logType;
        this.message = message;
        this.equipmentCode = equipmentCode;
        this.equipmentName = equipmentName;
        this.createDatetime = createDatetime;
        this.createUser = createUser;
        this.modifyDatetime = modifyDatetime;
        this.modifyUser = modifyUser;
    }

}
