package cn.estsh.i3plus.ext.mes.pojo.model.report;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.util.StringUtils;

import java.io.Serializable;

@Data
@ApiModel("检验产品数据总报表")
public class MesInspectionProductDataAmountReportModel implements Serializable {

    private static final long serialVersionUID = -2963567250001047604L;

    //-----------查询条件-------------

    @ApiParam(value = "组织代码")
    private String organizeCode;

    @ApiParam(value = "检验日期起始")
    private String inspectionDateStart;

    @ApiParam(value = "检验日期截止")
    private String inspectionDateEnd;

    @ApiParam(value = "NC判定时间起始")
    private String modifyDateTimeStart;

    @ApiParam(value = "NC判定时间截止")
    private String modifyDateTimeEnd;

    @ApiParam(value = "零件号")
    private String partNo;

    @ApiParam(value = "零件名称")
    private String partName;

    @ApiParam(value = "零件条码")
    private String productSn;

    @ApiParam("生产线代码")
    private String workCenterCode;

    @ApiParam("检验人")
    private String createUser;

    @ApiParam("检验结果")
    private Integer inspectionStatus;

    @ApiParam("NC判定结果")
    private Integer ncStatus;

    @ApiParam("NC处理结果")
    private Integer taskStatus;

    @ApiParam("缺陷位置")
    private String defectLocation;

    @ApiParam("正面反面(方向)")
    private Integer frontBack;

    @ApiParam("缺陷描述")
    private String defectTypeName;

    @ApiParam("责任库区")
    private String umlgo;

    @ApiParam("返工人")
    private String modifyUser;

    @ApiParam("返工单号")
    private String reworkOrder;

    @ApiParam("零件类型")
    private String partTypeCode;

//-----------展示列-------------

    @ApiParam(value = "id")
    private Long id;

    @ApiParam(value = "pid")
    private Long pid;

    @ApiParam(value = "检验日期")
    private String inspectionDate;

    @ApiParam(value = "条码")
    private String sn;

    @ApiParam("数量")
    private Double qty;

    @ApiParam("生产线名称")
    private String workCenterName;

    @ApiParam("检验结果(名称)")
    private String inspectionStatusName;

    @ApiParam("方向")
    private String frontBackName;

    @ApiParam("NC判定结果(名称)")
    private String ncStatusName;

    @ApiParam("源库区")
    private String lgort;

    @ApiParam("NC处理结果(名称)")
    private String taskStatusName;

    @ApiParam(value = "NC判定时间")
    private String modifyDatetime;

    @ApiParam("NC判定人")
    private String ncModifyUser;

    @ApiParam("zrsum")
    private String zrsum;

    public MesInspectionProductDataAmountReportModel() {}

    public MesInspectionProductDataAmountReportModel(Long id, Long pid, String inspectionDate, String modifyDatetime, String partName, String partNo, String sn, Double qty, String workCenterCode,
                                                     String createUser, String ncModifyUser, Integer inspectionStatus, Integer ncStatus, String defectLocation, Integer frontBack, String defectTypeName,
                                                     String lgort, String umlgo, String zrsum, Integer taskStatus, String reworkOrder, String modifyUser, String partTypeCode, String workCenterName) {
        this.id = id;
        this.pid = pid;
        this.inspectionDate = inspectionDate;
        this.modifyDatetime = modifyDatetime;
        this.partName = partName;
        this.partNo = partNo;
        this.sn = sn;
        this.qty = qty;
        this.workCenterCode = workCenterCode;
        this.createUser = createUser;
        this.ncModifyUser = ncModifyUser;
        this.inspectionStatus = inspectionStatus;
        this.ncStatus = ncStatus;
        this.defectLocation = defectLocation;
        this.frontBack = frontBack;
        this.defectTypeName = defectTypeName;
        this.lgort = lgort;
        this.umlgo = umlgo;
        this.zrsum = zrsum;
        this.taskStatus = taskStatus;
        this.reworkOrder = reworkOrder;
        this.modifyUser = modifyUser;
        this.partTypeCode = partTypeCode;
        this.workCenterName = workCenterName;
    }

}
