package cn.estsh.i3plus.ext.mes.pojo.model.report;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.util.StringUtils;

import java.io.Serializable;

@Data
@ApiModel("加工记录合并批量汇报查询报表")
public class MesProductionRecordReportExtModel implements Serializable {

    private static final long serialVersionUID = 7580273561023637832L;

    @ApiParam(value = "组织代码")
    private String organizeCode;

    @ApiParam(value = "物料编号")
    private String partNo;

    @ApiParam(value = "物料名称")
    private String partName;

    @ApiParam("生产线代码")
    private String workCenterCode;

    @ApiParam(value = "工位代码")
    private String workCellCode;

    @ApiParam(value = "数量")
    private Integer qty;

    @ApiParam("班次代码")
    private String shiftCode;

    @ApiParam(value = "设备代码")
    public String equipmentCode;

    @ApiParam("设备名称")
    private String equipmentName;

    @ApiParam(value = "汇报状态")
    private String reportStatusList;

    @ApiParam(value = "完成时间开始日期")
    private String completeDateTimeStart;

    @ApiParam(value = "完成时间结束日期")
    private String completeDateTimeEnd;

    //1=加工记录 2=工单日志批量汇报
    @ApiParam("数据来源")
    private Integer dataSource;

    @ApiParam("汇报状态")
    private Integer reportStatus;

    @ApiParam("汇报状态名称")
    private String reportStatusName;

    public MesProductionRecordReportExtModel() {}

    public MesProductionRecordReportExtModel(Object workCenterCode, Object workCellCode, Object partNo, Object partName, Object shiftCode, Object equipmentCode, Object equipmentName, Object reportStatus, Object dataSource, Object qty) {
        if (!StringUtils.isEmpty(workCenterCode)) this.workCenterCode = (String) workCenterCode;
        if (!StringUtils.isEmpty(workCellCode)) this.workCellCode = (String) workCellCode;
        if (!StringUtils.isEmpty(partNo)) this.partNo = (String) partNo;
        if (!StringUtils.isEmpty(partName)) this.partName = (String) partName;
        if (!StringUtils.isEmpty(shiftCode)) this.shiftCode = (String) shiftCode;
        if (!StringUtils.isEmpty(equipmentCode)) this.equipmentCode = (String) equipmentCode;
        if (!StringUtils.isEmpty(equipmentName)) this.equipmentName = (String) equipmentName;
        if (!StringUtils.isEmpty(reportStatus)) this.reportStatus = Integer.valueOf(reportStatus.toString());
        if (!StringUtils.isEmpty(dataSource)) this.dataSource = Integer.valueOf(dataSource.toString());
        if (!StringUtils.isEmpty(qty)) this.qty = Double.valueOf(qty.toString()).intValue();
    }
}
